      SUBROUTINE U3DREL(A,ANAME,II,JJ,KK,IN,IOUT)
C
C
C-----VERSION 1 20AUGUST U3DREL
C     ******************************************************************
C     ROUTINE TO INPUT 3-D REAL DATA MATRICES
C       A IS ARRAY TO INPUT
C       ANAME IS 24 CHARACTER DESCRIPTION OF A
C       II IS NO. OF ROWS
C       JJ IS NO. OF COLS
C       KK IS LAYER NO.
C       IN IS INPUT UNIT
C       IOUT IS OUTPUT UNIT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*4 ANAME
      CHARACTER*20 FMTIN
      DIMENSION A(JJ,II,KK),ANAME(6)
C     ------------------------------------------------------------------
C
C1------READ ARRAY CONTROL RECORD.
      READ (IN,1) LOCAT,CNSTNT,FMTIN,IPRN
    1 FORMAT(I10,F10.0,A20,I10)
C
C2------USE LOCAT TO SEE WHERE ARRAY VALUES COME FROM.
      IF(LOCAT) 200,50,90
C
C3------IF LOCAT=0 THEN SET ALL ARRAY VALUES EQUAL TO CNSTNT. RETURN
   50 DO 80 K=1,KK
      DO 80 I=1,II
      DO 80 J=1,JJ
   80    A(J,I,K)=CNSTNT
      WRITE(IOUT,2) ANAME,CNSTNT,KK
    2 FORMAT(1H0,52X,6A4,' =',G15.7,' FOR ',I3,' LAYERS')
      RETURN
C
C4------IF LOCAT>0 THEN READ FORMATTED RECORDS USING FORMAT FMTIN.
   90 WRITE(IOUT,4) ANAME,KK,LOCAT,FMTIN
    4 FORMAT(1H0,///30X,6A4,' FOR ',I3,' LAYERS WILL BE READ ON UNIT',
     1       I3,' USING FORMAT: ',A20/30X,96('-'))
      DO 100 K=1,KK
      DO 100 I=1,II
         READ (LOCAT,FMTIN) (A(J,I,K), J=1,JJ)
  100 CONTINUE
      GO TO 300
C
C5------LOCAT<0 THEN READ UNFORMATTED RECORD CONTAINING ARRAY VALUES
  200 LOCAT=-LOCAT
      WRITE(IOUT,201) ANAME,KK,LOCAT
  201 FORMAT(1H0,///30X,6A4,', FOR ',I3,' LAYERS',
     1    ' WILL BE READ UNFORMATTED ON UNIT',I3/30X,73('-'))
C
C5A------READ AN UNFORMATTED DUMMY RECORD FIRST.
      READ(LOCAT)
      READ(LOCAT) A
C
C6------IF CNSTNT NOT ZERO THEN MULTIPLY ARRAY VALUES BY CNSTNT.
  300 IF(CNSTNT.EQ.0.) GO TO 320
      DO 310 K=1,KK
      DO 310 I=1,II
      DO 310 J=1,JJ
      A(J,I,K)=A(J,I,K)*CNSTNT
  310 CONTINUE
C
C7------IF PRINT CODE (IPRN) =>0 THEN PRINT ARRAY VALUES.
  320 IF(IPRN.LT.0) RETURN
      DO 400 K=1,KK
         KKK=K
         CALL ULAPRW(A(1,1,KKK),ANAME,0,0,JJ,II,KKK,IPRN,IOUT)
  400 CONTINUE
      RETURN
C
C8------RETURN
      END
